%Demonstration of impacts of angle errors on MV beamforming
%developed by Wing-kin Ma, March 2013

m= 10; %array size

angle_des= 20;
angle_err= 0.01;
angle_res= 200;


%theta_noi= [ (-pi/2):(pi/angle_res):(((angle_des-cut_off_angle)*(pi/180))) ];
%theta_noi= [ theta_noi ((angle_des+cut_off_angle)*(pi/180)):(pi/angle_res):(pi/2) ];
%L= length(theta_noi);
%R= zeros(m,m);
%for i=1:length(theta_noi)
%    a= steering_vec(theta_noi(i),m)/m;
%    R= R+ a*(a');
%end;

R= zeros(m,m);
at= steering_vec(20*(pi/180),m);
at2= steering_vec(40*(pi/180),m); 
at3= steering_vec(-50*(pi/180),m); 
R= at*at'+at2*at2'+at3*at3';
R= R + 0.01*eye(m);
inv_R= inv(R);

a_des= steering_vec(angle_des*(pi/180),m);
w1= inv_R*a_des/real(a_des'*inv_R*a_des);
a_des= steering_vec((angle_des-angle_err)*(pi/180),m);
w2= inv_R*a_des/real(a_des'*inv_R*a_des);

theta= -pi/2:(pi/1000):pi/2;
P1= zeros(length(theta),1); P2= zeros(length(theta),1);
for i=1:length(theta)
    P1(i)= abs(w1'*steering_vec(theta(i),m)).^2;
    P2(i)= abs(w2'*steering_vec(theta(i),m)).^2;
end;

figure(1); clf;
plot(theta*(2/pi*90),10*log10(P1),'linewidth',2); hold on;
plot(theta*(2/pi*90),10*log10(P2),'r--','linewidth',2);
xlabel('Angle (Degree)'); ylabel('Magnitude (dB)');
legend('MV without angle error',['MV with angle error, error=',num2str(angle_err)]);
%sx(-90,90);
set(gca,'XLim',[-90 90]);