function w= rmv_socp_cvx(R,a,epsi)

%----------------------------------
% Demo: Robust beamforming via SOCP

% by  Wing-Kin Ma and Jiaxian Pan and, March 2013
%
% Problem: 
%
% min  t 
% s.t. ||V w|| <= t
%      epsi* ||w||<= w^H a -1
%      Imag(w^H a)=0
%
% where V is the Cholesky factor of R, i.e. R=V^H V
%       || || is the 2-norm
%       Imag( ) is the imaginary part.
%


%-------------
%for sedumi
% m= size(a,1);
% 
% %set up sedumi for robust beamforming
% U= chol(R);
% breve_U= [ real(U) -imag(U); imag(U) real(U) ];
% breve_a1= [ real(a); imag(a) ];
% breve_a2= [ imag(a); -real(a) ];
% %1: equality for first cone
% At= zeros(1,2+4*m);
% At(1,1:(2*m+1))= [ epsi -breve_a1' ]; bt= -1;
% %2: equalty for zero imag
% At= [ At; 0 breve_a2' zeros(1,2*m+1) ]; bt= [ bt; 0 ];
% %2: equalty for 2nd cone
% At= [ At; zeros(2*m,1) breve_U zeros(2*m,1) -eye(2*m) ]; 
% bt= [ bt; zeros(2*m,1) ];
% % others
% clear Kt;
% Kt.q= [2*m+1]; Kt.q= [Kt.q 2*m+1];
% ct= [ zeros(2*m+1,1); 1; zeros(2*m,1) ];
% %run sedumi
% [xt,yt]= sedumi(sparse(At),sparse(bt),sparse(ct),Kt);
% w= xt(2:(1+m))+ j*xt((m+2):(2*m+1));

%------------
%for cvx
m=size(a,1);
V=chol(R);

cvx_begin
variable w(m) complex;
variable t;

minimize(t)
subject to
norm(V*w) <=t;
epsi*norm(w)<=real(w'*a)-1;
imag(w'*a)==0;
cvx_end
